<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [FirstAvailableHost](#firstavailablehost)
    -   [request](#request)
    -   [get](#get)
    -   [post](#post)
    -   [postJson](#postjson)
-   [Pool](#pool)
    -   [preparePath](#preparepath)
    -   [prepareRequest](#preparerequest)
-   [Queue](#queue)
-   [HostsQueue](#hostsqueue)
    -   [request](#request-1)
    -   [get](#get-1)
    -   [post](#post-1)
    -   [postJson](#postjson-1)

## FirstAvailableHost

**Extends Pool**

Пул, осуществляющий обращение к первому доступному хосту.

**Parameters**

-   `hosts` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Массив хостов или URL
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Дополнительные параметры
    -   `params.timeout` **[number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** Максимальный таймаут запроса (optional, default `10000`)
    -   `params.headers` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Дополнительные заголовки, добавляемые к каждому запросу (optional, default `{}`)

### request

Метод выполняет запрос к первому доступному хосту из списка.

**Parameters**

-   `method` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Метод запроса
-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса
-   `dataType` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)?** Тип передаваемых данных: json или application/x-www-form-urlencoded

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

### get

Выполняет GET запрос.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

### post

Выполняет POST запрос.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

### postJson

Выполняет POST запрос с отправкой JSON объекта.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `data` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Объект для отправки в виде JSON

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

## Pool

Базовый класс для реализации пулов.

**Parameters**

-   `hosts` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Массив хостов
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Дополнительные параметры
    -   `params.timeout` **[number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** Максимальный таймаут запроса (optional, default `10000`)
    -   `params.headers` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Дополнительные заголовки, добавляемые к каждому запросу (optional, default `{}`)

### preparePath

Метод подготавливает путь запроса.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Базовый путь
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса

Returns **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** 

### prepareRequest

Метод подготавливает запрос.

**Parameters**

-   `method` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Метод запроса
-   `host` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Хост
-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса
-   `dataType` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Тип передаваемых данных: json или application/x-www-form-urlencoded

Returns **{request: {hostname: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String), port: [number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number), method: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String), headers: {}}, data: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String), protocol: [string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)}** 

## Queue

Класс очереди для массива хостов.

**Parameters**

-   `hosts` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Массив хостов

## HostsQueue

**Extends Pool**

Пул, осуществляющий запросы к хостам по очереди.

**Parameters**

-   `hosts` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Массив хостов
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Дополнительные параметры
    -   `params.timeout` **[number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** Максимальный таймаут запроса (optional, default `10000`)
    -   `params.headers` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Дополнительные заголовки, добавляемые к каждому запросу (optional, default `{}`)

### request

Метод выполняет запрос к следующему по очереди хосту из списка.
При достижении конца списка, индекс сбрасывается на начало.
Недоступные хосты пропускаются.

**Parameters**

-   `method` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Метод запроса
-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса
-   `dataType` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)?** Тип передаваемых данных: json или application/x-www-form-urlencoded

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

### get

Выполняет GET запрос.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

### post

Выполняет POST запрос.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `params` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Параметры запроса

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 

### postJson

Выполняет POST запрос с отправкой JSON объекта.

**Parameters**

-   `path` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Путь запроса
-   `data` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Объект для отправки в виде JSON

Returns **[Promise](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Promise)&lt;[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)>** 
